import { RequestOptions } from './types';
/**
 * streaming data with axios
 * https://maximorlov.com/send-a-file-with-axios-in-nodejs/
 *
 * Multipart boundary data
 * https://stackoverflow.com/questions/3508338/what-is-the-boundary-in-multipart-form-data
 */
/**
 *
 * @param {API.Config} clusterClient
 * @param {string} path
 * @param {Object} [options]
 * @param {string} [options.method]
 * @param {Record<string, string|number|boolean|null|undefined>} [options.params]
 * @param {BodyInit} [options.body]
 * @param {AbortSignal} [options.signal]
 */
export declare function request(baseUrl: string, path: string, headers: Record<string, string>, options?: RequestOptions): Promise<any>;
